package bsp3;

// Komplexeres Beispiel mit Ausgabe in einer Tabelle
// Schalter und ComboBox vereinfachen die Aktionen

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

import java.sql.*;
import javax.swing.table.*;
import java.util.Vector;

import javax.swing.event.TableModelEvent;

/**
 *
 * @author 545
 */
public class bsp3 extends JFrame {
  JLabel lFormel;
  JComboBox TSql;
  JToolBar toolBar;
  JButton BnCalc;
  JPanel _tablePanel;

  Vector _tableRows = new Vector();  // speichert die Tupel, Zeilen
  Vector<String> _tableHeader = new Vector<String>();  // speichert die Header der Tabelle, zum Einfgen und Namen

  int _AnzCols;
  int _AnzRows;
  JTable _tabelle;  // Tabelle

  TableModel _dataModel;

   public bsp3() {
     setSize(1000, 600);
     this.setLocation(10, 10);
     this.setTitle("Beispiel Firebird 3");
     setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
     setGUI();
    }


 private void setGUI() {
    this.getContentPane().setLayout( new BorderLayout() );

    toolBar = new JToolBar();

    BnCalc = new JButton( "Starte SQL" );
    BnCalc.setFont( new Font("Arial", Font.BOLD,28));
    BnCalc.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnSQL_Start_Click();
       }
    });

    toolBar.add(BnCalc);
    this.getContentPane().add(toolBar, BorderLayout.NORTH);

    _tablePanel = new JPanel();
    this.getContentPane().add(_tablePanel, BorderLayout.CENTER);
    _tablePanel.setLayout( new GridBagLayout() );

      lFormel = new JLabel("SQL-Befehl");
      lFormel.setFont( new Font("Arial", Font.BOLD,18) );
      _tablePanel.add(lFormel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(20,20,0,0), 0, 6));

      String sTable="employee";

        // ComboBox mit Eingabe
      String[] items = new String[4];
      items[0] = "SELECT EMP_NO, Full_name, DEPT_NO, SALARY FROM " + sTable;
      items[1] = "SELECT *  FROM " + sTable;
      items[2] = "SELECT *  FROM " + sTable+"  WHERE SALARY > 70000.0";
      items[3] = "SELECT EMP_NO, Last_name, First_name, DEPT_NO, SALARY FROM " + sTable+"  WHERE SALARY > 70000.0";

      TSql = new JComboBox(items);
      TSql.setFont( new Font("Arial", Font.PLAIN,18) );
      _tablePanel.add(TSql,   new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
              ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(20,40,0,20), 00, 0));
      TSql.setEditable(true);



    JLabel lLabel2 = new JLabel("Ergebnisse:");
    lLabel2.setFont( new Font("Arial", Font.PLAIN,18) );
    _tablePanel.add(lLabel2,   new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(40,20,0,20), 00, 0));

    // Defaulteintrag, wichtig fuer die Methode createTabelle
    _tableRows.removeAllElements();
    Vector tupel;
    tupel = new Vector();
    tupel.add("leer");
    _tableRows.add( tupel );

    tupel = new Vector();
    tupel.add("leer");
    _tableRows.add( tupel );

    _tableHeader.removeAllElements();
    _tableHeader.add("leer");
     _AnzCols=1;
     _AnzRows = _tableRows.size();


    _tabelle = createTable();
    _tabelle.setFont( new Font("Monospaced", Font.PLAIN,18) );
    _tabelle.setRowHeight(20);
    // setShowVerticalLines
    // setIntercellSpacing(new Dimension(spacing, spacing)
    JScrollPane scrollpane = new JScrollPane(_tabelle);
    _tablePanel.add(scrollpane,   new GridBagConstraints(0, 2, 2, 1, 1.0, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(20,20,0,20), 00, 0));
  } // setGUI



  void BnSQL_Start_Click() {
      try {
        startsql_1();
      } catch( Exception ex ) {
        System.out.println( ex );
      }
      
      
  }


    public void startsql_1()  throws Exception  {
      int i;
      int AnzCols_old;
      String sDbDrv;
      String sDbUrl;

      // String sTable="employee";
      String sUsr="sysdba";
      String sPwd="masterkey";

      sDbDrv = "org.firebirdsql.jdbc.FBDriver";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\EMPLOYEE.FDB";
      sDbUrl="jdbc:firebirdsql:localhost/3050:"+
              "D:\\IGM_2014\\Strukturguete\\IGMStrukturguete\\IGMStrukturguete\\bin\\Debug\\TEST.FDB";

        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;

      AnzCols_old = _AnzCols;  // Merken der alten Spalten
      try {
        // Treiber INIT, Verbinden  und SQL-Statement auslsen
          
        
        Class.forName( sDbDrv );  // erzeugen und 
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();

          // SQL-Statement
        String sql = (String) TSql.getSelectedItem();
        rs = st.executeQuery( sql );

        // Get meta data:
        ResultSetMetaData rsmd = rs.getMetaData();
        _AnzCols = rsmd.getColumnCount();  // neue Felder
        System.out.println("_AnzCols "+_AnzCols);


          // Alles lschen
        _tableHeader.removeAllElements();
        _tableRows.removeAllElements();

          // Man braucht den Vektor headerNames, da jetzt noch nicht
         // alle Spalten vorhanden sind.
        for( i=0; i<_AnzCols; i++ ) {   // Attention: first column with 1 instead of 0
          _tableHeader.add( rsmd.getColumnName( i+1 ) );
          System.out.println("header("+i+") "+rsmd.getColumnName( i+1 ) );
        }


          // Schleife ber alle Tupel
        while( rs.next() ) {
            // neue Zeile
            // Zeile aller Daten
          Vector Tupel = new Vector();
          for( i=0; i<_AnzCols; i++ ) { // Attention: first column with 1 instead of 0
            Tupel.add ( rs.getString( i+1 ) );
          }
            // Tupel zur Gesamtliste hinzufgen
          _tableRows.add( Tupel );
        }
        _AnzRows = _tableRows.size();
        System.out.println("_AnzRows "+_AnzRows);
        // ohne die naechste Anweisung erkennt die Tabelle nicht die Aenderung
        // if (false)
        _tabelle.tableChanged(
                new TableModelEvent(_dataModel, 
                        TableModelEvent.HEADER_ROW));

        _tabelle.updateUI();


      } catch( Exception ex ) {
        System.out.println( ex );
      } finally {
        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
        try { if( null != st ) st.close(); } catch( Exception ex ) {}
        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
      }
    }     // sql


      // createTable
  public JTable createTable() {
         // Das Datenmodell muss global sein
        _dataModel = new AbstractTableModel() {
            // These methods always need to be implemented.
            public int getColumnCount() {
              System.out.println( " **** AnzCol: "+_AnzCols );
              return _AnzCols;
            }
            public int getRowCount() {
              // System.out.println( " **** AnzRows: "+_tableRows.size() );
              return _tableRows.size();
            }

                // Speicherung mittels Vector und Vector
            public Object getValueAt(int row, int col) {
                Vector tupel = (Vector) _tableRows.elementAt(row);
                // if (row<2) System.out.println( tupel.elementAt(col) );
                  return tupel.elementAt(col);
            }

            // The default implementations of these methods in
              // AbstractTableModel would work, but we can refine them.
            public String getColumnName(int column) {
                if ( (column)< _tableHeader.size() ) {
                    return  _tableHeader.elementAt(column);
                } else {
                    return "X";
                }
            }
            public Class getColumnClass(int c) {
              return getValueAt(0, c).getClass();
            }
            public boolean isCellEditable(int row, int col) {
              return false;
            }
            /*
            public void setValueAt(Object aValue, int row, int column) {
                System.out.println("Setting value to: " + aValue);
                data[row][column] = aValue;
            }
            */
         };

     JTable table = new JTable(_dataModel); // , _TableColModel);


     table.setFont( new Font("Arial", Font.PLAIN,24) );
     table.setRowHeight(30);
     table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
     table.setAutoCreateColumnsFromModel(true);

     return table;
  } // createTable


    public static void main(String[] args) {
      bsp3 frame = new bsp3();
      frame.setVisible(true);
    }


}
