package bsp5;

import javax.swing.*;

import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.awt.*;

import java.awt.event.*;

import java.sql.*;

import javax.swing.table.*;
import java.util.Vector;

public class Frame_Group extends JFrame {

    // Definition der GUI-Elemente
  JLabel      LEmpNo;
  JTextField  TEmpNo;

  JLabel      LFirstName;
  JTextField  TFirstName;

  JLabel      LLastName;
  JTextField  TLastName;

  JLabel      LDeptNo;
  JTextField  TDeptNo;

  JLabel      LSalary;
  JTextField  TSalary;
  
  JButton BnUp = new JButton("Up");
  JButton BnDown = new JButton("Down");
  JButton BnEsc = new JButton("Abbruch");

    int _AnzCols;
    int _AnzRows;
    int _AktRow;
    
      Vector _tableErgs;  // speichert die Tupel



    public Frame_Group() {
        setSize(400, 350);  // width height
        setLocation(10,200);  // x/y
        setTitle("Anzeige eines Mitarbeiters");
        this.getContentPane().setLayout( new GridBagLayout() );
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setGUI();
        _tableErgs = new Vector();
          try {
            startsql_1();  
          } catch( Exception ex ) {
            System.out.println( ex );
          }    
        if (_tableErgs.size()>0) {
            _AktRow=0;
            setDataBase2GUI();
        }
    }
    
  void setGUI() {
    LEmpNo = new JLabel("Mitarbeiternummer");
    TEmpNo = new JTextField("");
    LEmpNo.setFont( new Font("Arial", Font.BOLD,20));
    TEmpNo.setFont( new Font("Arial", Font.BOLD,20));

    this.getContentPane().add(LEmpNo, 
            new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
            new Insets(0,20,0,0), 0, 6));

    this.getContentPane().add(TEmpNo,   
            new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
            new Insets(0,20,0,20), 22, 6));

    
    LFirstName = new JLabel("Vorname");
    TFirstName = new JTextField("");
    LFirstName.setFont( new Font("Arial", Font.BOLD,20));
    TFirstName.setFont( new Font("Arial", Font.BOLD,20));

    this.getContentPane().add(LFirstName, 
            new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
            new Insets(10,20,0,0), 0, 6));

    this.getContentPane().add(TFirstName,   
            new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
            new Insets(10,20,0,20), 22, 6));
    
    LLastName = new JLabel("Nachname");
    TLastName = new JTextField("");
    LLastName.setFont( new Font("Arial", Font.BOLD,20));
    TLastName.setFont( new Font("Arial", Font.BOLD,20));
        
    this.getContentPane().add(LLastName, 
            new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
            new Insets(10,20,0,0), 0, 6));

    this.getContentPane().add(TLastName,   
            new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
            new Insets(10,20,0,20), 22, 6));

    LDeptNo = new JLabel("Abteilung");
    TDeptNo = new JTextField("");
    LDeptNo.setFont( new Font("Arial", Font.BOLD,20));
    TDeptNo.setFont( new Font("Arial", Font.BOLD,20));
        
    this.getContentPane().add(LDeptNo, 
            new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
            new Insets(10,20,0,0), 0, 6));

    this.getContentPane().add(TDeptNo,   
            new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
            new Insets(10,20,0,20), 22, 6));
    
    
    LSalary = new JLabel("Gehalt");
    TSalary = new JTextField("");
    LSalary.setFont( new Font("Arial", Font.BOLD,20));
    TSalary.setFont( new Font("Arial", Font.BOLD,20));
        
    this.getContentPane().add(LSalary, 
            new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
            new Insets(10,20,0,0), 0, 6));

    this.getContentPane().add(TSalary,   
            new GridBagConstraints(1, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
            new Insets(10,20,0,20), 22, 6));
    

            
    BnUp = new JButton("Up");
    BnUp.setFont( new Font("Arial", Font.BOLD,20));
      // Verkn�pfen des Schalters mit einer Methode
    BnUp.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnUp_Click();
      }
    });
    
    BnDown = new JButton("Down");
    BnDown.setFont( new Font("Arial", Font.BOLD,20));
      // Verkn�pfen des Schalters mit einer Methode
    BnDown.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnDown_Click();
      }
    });


    // -------------------
    BnEsc = new JButton("Abbruch");
    BnEsc.setFont( new Font("Arial", Font.BOLD,20));
    BnEsc.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnEsc_Click();
      }
    });
    // -------------------
    JPanel panelBn = new JPanel();
    panelBn.setLayout( new FlowLayout() );    
    panelBn.add(BnDown);
    panelBn.add(BnUp);
    panelBn.add(BnEsc);
    this.getContentPane().add(panelBn,  
            new GridBagConstraints(0, 5, 2, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, 
            new Insets(20,0,0,0), 0, 0));
  }  // setGUI


  void BnUp_Click() {
     if (_AktRow<(_tableErgs.size()-1) ) {
            _AktRow++;
            setDataBase2GUI();
     }
  }  // BnOk
  
  void BnDown_Click() {
     if ( _AktRow>0 ) {
            _AktRow--;
            setDataBase2GUI();
     }
  }  // BnOk
  
  void setDataBase2GUI(){
      Vector Tupel;
      Tupel = (Vector)_tableErgs.elementAt(_AktRow);
      TEmpNo.setText( (String) Tupel.elementAt(0) );
      TFirstName.setText( (String) Tupel.elementAt(1) );
      TLastName.setText( (String) Tupel.elementAt(2) );
      TDeptNo.setText( (String) Tupel.elementAt(3) );
      TSalary.setText( (String) Tupel.elementAt(4) );
      
  }

  void BnEsc_Click() {
    setTitle("Abbruch gedrueckt");
    this.dispose();
  }


    public void startsql_1()  throws Exception  {
      int i;      
      String sDbDrv;
      String sDbUrl;

      String sTable="employee";
      String sUsr="sysdba";
      String sPwd="masterkey";

      sDbDrv = "org.firebirdsql.jdbc.FBDriver";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\java\\netbeans\\jdbc\\bsp5\\build\\classes\\bsp5\\TEST.GDB";

        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;

      try {        
        // Treiber INIT, Verbinden  und SQL-Statement ausl�sen
        Class.forName( sDbDrv );
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();
      
          // SQL-Statement
        String sql = "SELECT * FROM EMP";
        rs = st.executeQuery( sql );

        // Get meta data:
        ResultSetMetaData rsmd = rs.getMetaData();
        _AnzCols = rsmd.getColumnCount();  // neue Felder
        System.out.println("_AnzCols "+_AnzCols);

      
          // Alles l�schen        
        _tableErgs.removeAllElements();
        
        _AnzRows = 0;
          // Schleife �ber alle Tupel
        while( rs.next() ) {
            // neue Zeile
          _AnzRows++;
            // Zeile aller Daten
          Vector Tupel = new Vector();
          for( i=0; i<_AnzCols; i++ ) { // Attention: first column with 1 instead of 0
            Tupel.add ( rs.getString( i+1 ) );
          }
            // Tupel zur Gesamtliste hinzuf�gen
          _tableErgs.add( Tupel );
        }
        System.out.println("_AnzRows "+_AnzRows);
        //LErgebnisse.setText("Ergebnisse: "+_AnzRows+" Tupel");
        

      } catch( Exception ex ) {
        System.out.println( ex );
      } finally {
        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
        try { if( null != st ) st.close(); } catch( Exception ex ) {}
        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
      }
    }     // sql
  
  
}
