package bsp5;

import javax.swing.*;

import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.awt.*;

import java.awt.event.*;

import java.sql.*;

import javax.swing.table.*;
import java.util.Vector;


class Frame_Insert extends JFrame {

    // Definition der GUI-Elemente
  JLabel      LDeptNo;
  JTextField  TDeptNo;

  JLabel      LName;
  JTextField  TName;

  JButton BnOk = new JButton("Ok");
  JButton BnEsc = new JButton("Abbruch");


    public Frame_Insert() {
    setSize(400, 250);  // width height
    setLocation(10,200);  // x/y
    setTitle("Eingabe eines Vereins");
    this.getContentPane().setLayout( new GridBagLayout() );
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setGUI();
    }
    
  void setGUI() {
    LDeptNo = new JLabel("Abteilungsnr");
    TDeptNo = new JTextField("");
    LDeptNo.setFont( new Font("Arial", Font.BOLD,20));
    TDeptNo.setFont( new Font("Arial", Font.BOLD,20));

    LName = new JLabel("Abteilungsname");
    TName = new JTextField("");
    LName.setFont( new Font("Arial", Font.BOLD,20));
    TName.setFont( new Font("Arial", Font.BOLD,20));

    this.getContentPane().add(LDeptNo, 
            new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
            new Insets(0,20,0,0), 0, 6));

    this.getContentPane().add(TDeptNo,   
            new GridBagConstraints(1, 0, 3, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
            new Insets(0,20,0,20), 22, 6));

    
    this.getContentPane().add(LName, 
            new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
            new Insets(0,20,0,0), 0, 6));

    this.getContentPane().add(TName,   
            new GridBagConstraints(1, 1, 3, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
            new Insets(0,20,0,20), 22, 6));

    

            
    BnOk = new JButton("Ok");
    BnOk.setFont( new Font("Arial", Font.BOLD,20));
      // Verkn�pfen des Schalters mit einer Methode
    BnOk.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        BnOk_Click();
      }
    });


    // -------------------
    BnEsc = new JButton("Abbruch");
    BnEsc.setFont( new Font("Arial", Font.BOLD,20));
    BnEsc.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnEsc_Click();
      }
    });
    // -------------------
    JPanel panelBn = new JPanel();
    panelBn.add(BnOk);
    panelBn.add(BnEsc);
    this.getContentPane().add(panelBn,  new GridBagConstraints(1, 1, 3, 2, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(40,0,0,20), 0, 0));
  }  // setGUI


  void BnOk_Click() {
      String sDeptNr, sName;
      long DeptNr;
      sDeptNr = TDeptNo.getText().trim();
      
      sName = TName.getText().trim();
      if (sName.length()<2) {
        basis.Error("Fehler","Bitte einen l�ngeren Namen eingeben");
        return;
      }
      if (! basis.LVal(sDeptNr) ) {
        basis.Error("Fehler","Bitte eine g�ltige Abteilungsnummer eingeben");
        return;
      }
      DeptNr=basis.getLValResult();              
      if (!Insert(DeptNr,sName) ){
        basis.Error("Fehler","Fehler beim Insert");
        return;          
      }
  }  // BnOk
  
  
  boolean Insert(long DeptNr, String sDeptname) {
      String sDbDrv;
      String sDbUrl;
      String sTable;
      String sUsr;
      String sPwd;
      String sDeptNr;
   sTable="DEPT";
   sUsr="sysdba";
   sPwd="masterkey";

   sDbDrv = "org.firebirdsql.jdbc.FBDriver";
   sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\java\\netbeans\\jdbc\\bsp5\\build\\classes\\bsp5\\TEST.GDB";
        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;
      
      sDeptNr = Long.toString(DeptNr);

      try {
        // Treiber INIT, Verbinden  und SQL-Statement ausl�sen
        Class.forName( sDbDrv );
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();

          // SQL-Statement
        String sql;
        sql = "INSERT INTO DEPT (DEPTNO, DEPTNAME) "
                   +"VALUES("+sDeptNr+ ", '"+ sDeptname+"');";
        System.out.println(sql);
        int anz = st.executeUpdate( sql );
        System.out.println("Anzahl der Datens�tze die betroffen wurden: "+anz);
        return true;
     }
     catch( Exception ex ) {
        System.out.println( ex );
        return false;
     }
  }  // insert 

  void BnEsc_Click() {
    setTitle("Abbruch gedrueckt");
    this.dispose();
  }

    
}
