package bsp4;

// Komplexeres Beispiel mit Ausgabe in einer Tabelle
// Schalter und ComboBox vereinfachen die Aktionen
// Mit Insert

import javax.swing.*;


import java.awt.*;

import java.awt.event.*;

import java.sql.*;

import javax.swing.table.*;
import java.util.Vector;

import javax.swing.event.TableModelEvent;

public class bsp4 extends JFrame {
  JLabel lFormel;
  JComboBox TSql;
  JToolBar toolBar;
  JButton BnCalc;
  JButton BnInsert;
  JPanel _tablePanel;
  
  Vector _tableRows = new Vector();  // speichert die Tupel, Zeilen
  Vector<String> _tableHeader = new Vector<String>();  // speichert die Header der Tabelle, zum Einfgen und Namen
  TableModel _dataModel;
  int _AnzCols;
  int _AnzRows;

  //Vector _headerNames;  // speichert die Namen der Attribute
  JTable _tabelle;  // Tabelle

  

   public bsp4() {
     setSize(1000, 600);
     this.setLocation(10, 10);
     this.setTitle("Beispiel Firebird 4");
     setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
     setGUI();
    }
    

 private void setGUI() {
    this.getContentPane().setLayout( new BorderLayout() );
    toolBar = new JToolBar();
   
    BnCalc = new JButton( "Starte SQL" );
    BnCalc.setFont( new Font("Arial", Font.BOLD,28));
    BnCalc.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnSQL_Start_Click();
       }
    });
    
    BnInsert = new JButton( "Insert Mitarbeiter" );
    BnInsert.setFont( new Font("Arial", Font.BOLD,28));
    BnInsert.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
        BnSQL_Insert_Click();
       }
    });


    toolBar.add(BnCalc);
    toolBar.addSeparator();
    toolBar.add(BnInsert);
    this.getContentPane().add(toolBar, BorderLayout.NORTH);
    
    _tablePanel = new JPanel();
    this.getContentPane().add(_tablePanel, BorderLayout.CENTER);
    _tablePanel.setLayout( new GridBagLayout() );
   
      lFormel = new JLabel("SQL-Befehl");
      lFormel.setFont( new Font("Arial", Font.BOLD,18) );
      _tablePanel.add(lFormel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(20,20,0,0), 0, 6));


        // ComboBox mit Eingabe
      String[] items = new String[5];
      items[0] = "SELECT EMP_NO, Last_name, first_name, DEPT_NO, SALARY FROM EMPLOYEE";
      items[1] = "SELECT *  FROM EMPLOYEE";
      items[2] = "SELECT *  FROM DEpartment";
      items[3] = "SELECT *  FROM EMPLOYEE WHERE salary>300";
      items[4] = "SELECT * FROM EMPLOYEE, DEpartment  WHERE EMPLOYEE.dept_no = DEpartment.dept_no";
    
      TSql = new JComboBox(items);
      TSql.setFont( new Font("Arial", Font.PLAIN,18) );
      _tablePanel.add(TSql,   new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
              ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(20,40,0,20), 00, 0));
      TSql.setEditable(true);


    JLabel lLabel2 = new JLabel("Ergebnisse:");
    lLabel2.setFont( new Font("Arial", Font.PLAIN,18) );
    _tablePanel.add(lLabel2,   new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(40,20,0,20), 00, 0));


    // Defaulteintrag, wichtig fuer die Methode createTabelle
    _tableRows.removeAllElements();
    Vector tupel;
    tupel = new Vector();
    tupel.add("leer");
    _tableRows.add( tupel );

    tupel = new Vector();
    tupel.add("leer");
    _tableRows.add( tupel );

    _tableHeader.removeAllElements();
    _tableHeader.add("leer");
     _AnzCols=1;
     _AnzRows = _tableRows.size();


    _tabelle = createTable();
    _tabelle.setFont( new Font("Monospaced", Font.PLAIN,18) );
    _tabelle.setRowHeight(20);
    JScrollPane scrollpane = new JScrollPane(_tabelle);
    _tablePanel.add(scrollpane,   new GridBagConstraints(0, 2, 2, 1, 1.0, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(20,20,0,20), 00, 0));
  } // setGUI
 

 
  void BnSQL_Start_Click() {
      try {
        startsql_1();  
      } catch( Exception ex ) {
        System.out.println( ex );
      }    
  }
 

    public void startsql_1()  throws Exception  {
      int i;
      int AnzCols_old;
      String sDbDrv;
      String sDbUrl;
     
      String sUsr="sysdba";
      String sPwd="masterkey";

      sDbDrv = "org.firebirdsql.jdbc.FBDriver";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\EMPLOYEE.FDB";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\EMPLOYEE.FDB";      

        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;

      AnzCols_old = _AnzCols;  // Merken der alten Spalten
      try {        
        // Treiber INIT, Verbinden  und SQL-Statement auslsen
        Class.forName( sDbDrv );
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();
      
          // SQL-Statement
        String sql = (String) TSql.getSelectedItem();
        rs = st.executeQuery( sql );

        // Get meta data:
        ResultSetMetaData rsmd = rs.getMetaData();
        _AnzCols = rsmd.getColumnCount();  // Anzahl der Spalten
        System.out.println("_AnzCols "+_AnzCols);

      
          // Alles lschen
        _tableHeader.removeAllElements();
        _tableRows.removeAllElements();
        
          // Man braucht den Vektor headerNames, da jetzt noch nicht
         // alle Spalten vorhanden sind.
        for( i=0; i<_AnzCols; i++ ) {   // Attention: first column with 1 instead of 0
          _tableHeader.add( rsmd.getColumnName( i+1 ) );
          System.out.println("header("+i+") "+rsmd.getColumnName( i+1 ) );
        }        
          // Schleife ber alle Tupel
        while( rs.next() ) {
            // neue Zeile            
          Vector Tupel = new Vector();  // Zeile aller Daten
          for( i=0; i<_AnzCols; i++ ) { // Attention: first column with 1 instead of 0
            Tupel.add ( rs.getString( i+1 ) );
          }
            // Tupel zur Gesamtliste hinzufgen
          _tableRows.add( Tupel );
        }
        _AnzRows = _tableRows.size();
        System.out.println("_AnzRows "+_AnzRows);
         // ohne die naechste Anweisung erkennt die Tabelle nicht die Aenderung
        _tabelle.tableChanged(new TableModelEvent(_dataModel, TableModelEvent.HEADER_ROW));
        _tabelle.updateUI();

      } catch( Exception ex ) {
        System.out.println( ex );
      } finally {
        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
        try { if( null != st ) st.close(); } catch( Exception ex ) {}
        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
      }
    }     // sql


      // createTable
  public JTable createTable() {
    // Create a model of the data.
        _dataModel = new AbstractTableModel() {
            // These methods always need to be implemented.
            public int getColumnCount() {
                //System.out.println( " **** AnzCol: "+_tupel.size() );
              return _AnzCols;
            }
            public int getRowCount() {
              return _tableRows.size();
            }

                // Speicherung mittels Vector und Vector
            public Object getValueAt(int row, int column) {
                Vector tupel = (Vector) _tableRows.elementAt(row);
                  return tupel.elementAt(column);
            }

            public String getColumnName(int column) {
                if ( (column)< _tableHeader.size() ) {
                    return (String) _tableHeader.elementAt(column);
                } else {
                    return "X";
                }
            }
            public Class getColumnClass(int column) {
              return getValueAt(0, column).getClass();
            }
            public boolean isCellEditable(int row, int col) {
              return false;
            }
            /*
            public void setValueAt(Object aValue, int row, int column) {
            }
            */
         };

     
     JTable table = new JTable(_dataModel); // , _TableColModel);

     table.setFont( new Font("Arial", Font.PLAIN,24) );
     table.setRowHeight(30);
     table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
     table.setAutoCreateColumnsFromModel(true);

     return table;
  } // createTable

  
  
 void BnSQL_Insert_Click() {
     String name="", salary="", dept="";
    InputData frame = new InputData(this);
    frame.setVisible(true);
    if ( frame.getResult()  ) {
        name = frame.sRet1;
        salary = frame.sRet2;
        dept = frame.sRet3;
        if (!updatesql(name, salary, dept) ) {
            basis.Message("Datensatz einfgen","Insert-Befehl ist fehlgeschlagen");
        }
    }
  }

 boolean updatesql(String sName, String sSalary, String sDeptNr) {
     int empno;
     
      String sDbDrv;
      String sDbUrl;
      String sTable;
      String sUsr;
      String sPwd;
      String sEMPNO;
      
      String sql;
   
      
      sUsr="sysdba";   
      sPwd="masterkey";

      sDbDrv = "org.firebirdsql.jdbc.FBDriver";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\TEST.GDB";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\EMPLOYEE.FDB";
        // Verbindung zur Datenbank, Auslesen Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;      

      sEMPNO = getNewKey();
      try {
        // Treiber INIT, Verbinden  und SQL-Statement auslsen
        Class.forName( sDbDrv );
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();

          // SQL-Statement
        // String sql;
        sql = "INSERT INTO employee (EMP_NO, LAST_NAME, SALARY, DEPT_NO) "
                   +"VALUES("+sEMPNO+",   '"+sName+"', "+sSalary+",   "+sDeptNr+");";
                           
        System.out.println(sql);
        int anz = st.executeUpdate( sql );
        System.out.println("Anzahl der Datenstze die betroffen wurden: "+anz);
        return true;
     }
     catch( Exception ex ) {
        System.out.println( ex );
        return false;
     }
  }  // insert 
     
 
 String getNewKey() {
      String sNewKey="";
      String sDbDrv;
      String sDbUrl;

      String sUsr="sysdba";
      String sPwd="masterkey";

      sDbDrv = "org.firebirdsql.jdbc.FBDriver";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\TEST.GDB";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\EMPLOYEE.FDB";

        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;

      try {        
        // Treiber INIT, Verbinden  und SQL-Statement auslsen
        Class.forName( sDbDrv );
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();
      
          // SQL-Statement
        String sql = "SELECT MAX(EMP_NO) from EMPLOYEE";
        rs = st.executeQuery( sql );

        
          // Schleife ber alle Tupel
        while( rs.next() ) {
          String sNr = rs.getString( 1 );   
          long l = Long.parseLong(sNr);
          sNewKey= Long.toString( l+1);
        }
        
      } catch( Exception ex ) {
        System.out.println( ex );
      } finally {
        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
        try { if( null != st ) st.close(); } catch( Exception ex ) {}
        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
      
    }     // sql    
     return sNewKey;
 } // getMaxkey
 
 
   
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
      bsp4 frame = new bsp4();
      frame.setVisible(true);
    }
        
    
}




// JDialog zur Eingabe der Daten


class InputData extends JDialog {

  JLabel jLabel1 = new JLabel("Name");
  JTextField TName = new JTextField("");

  JLabel jLabel2 = new JLabel("Gehalt");
  JTextField TSalary = new JTextField();

  JLabel jLabel3 = new JLabel("Abteilung");
  JComboBox CDept;

  Vector liste1= new Vector();
  Vector liste2= new Vector();
  
  JButton BnOk = new JButton();
  JButton BnESC = new JButton();
  
  String sRet1;
  String sRet2;
  String sRet3;
  
  
   protected boolean result=false;

  public InputData(Frame parent) {
    super(parent);
    super.setModal(true);
    insertDepts();
    setGUI();
    centerScreen();
  }
  
  
  void insertDepts()  {
      int i;
      int AnzCols_old;
      String sDbDrv;
      String sDbUrl;

      String sUsr="sysdba";
      String sPwd="masterkey";

      sDbDrv = "org.firebirdsql.jdbc.FBDriver";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\TEST.GDB";
      sDbUrl="jdbc:firebirdsql:localhost/3050:D:\\hs-harz\\Vorlesungen\\dbs\\EMPLOYEE.FDB";

        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;

      try {        
        // Treiber INIT, Verbinden  und SQL-Statement auslsen
        Class.forName( sDbDrv );
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();
      
          // SQL-Statement
        String sql = "SELECT DEPT_NO, department from department";
        rs = st.executeQuery( sql );

        
          // Schleife ber alle Tupel
        while( rs.next() ) {
          liste1.add(  rs.getString( 1 ) );
          liste2.add(  rs.getString( 2 ) );   
        }

        CDept = new JComboBox(liste2);
        
        
      } catch( Exception ex ) {
        System.out.println( ex );
      } finally {
        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
        try { if( null != st ) st.close(); } catch( Exception ex ) {}
        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
      
    }     // sql
      
      
      
  }

      public void centerScreen() {
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension frameSize;
        java.awt.Dimension preset;
        preset = this.getSize();
        if (preset.height > screenSize.height)
            preset.height = screenSize.height;
        if (preset.width > screenSize.width)
            preset.width = screenSize.width;
        // set new pos:
        setBounds((screenSize.width - preset.width) / 2, (screenSize.height - preset.height) / 2,
            preset.width, preset.height);
    }



  private void setGUI() {
    //setLocation(300,300);
    setSize(450, 400);
    setTitle("Eingabefenster fr die Datenbank");
    this.getContentPane().setLayout( new GridBagLayout() );


    jLabel1.setFont( new Font("Arial", Font.BOLD,18)  );
    TName.setFont( new Font("Arial", Font.BOLD,18)  );


    jLabel2.setFont( new Font("Arial", Font.BOLD,18)  );
    TSalary.setFont( new Font("Arial", Font.BOLD,18)  );

    jLabel3.setFont( new Font("Arial", Font.BOLD,18)  );
    CDept.setFont( new Font("Arial", Font.BOLD,18)  );
 
    // -------------
    this.getContentPane().add(jLabel1,
         new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(0,25,40,0), 0, 0));

    this.getContentPane().add(TName,
        new GridBagConstraints(1, 0, 1, 1, 100.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(0,25,40,25), 0, 0));

    
    this.getContentPane().add(jLabel2,
         new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(0,25,40,0), 0, 0));

    this.getContentPane().add(TSalary,
        new GridBagConstraints(1, 1, 1, 1, 100.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(0,25,40,25), 0, 0));

    
    this.getContentPane().add(jLabel3,
         new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(0,25,40,0), 0, 0));

    this.getContentPane().add(CDept,
        new GridBagConstraints(1, 2, 1, 1, 10000.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(0,25,40,25), 0, 0));

    // -----------------------------------------
    
    
    
    BnOk.setText("Ok");
    BnESC.setText("Abbruch");
    BnOk.setFont( new Font("Arial", Font.BOLD,18)  );
    BnESC.setFont( new Font("Arial", Font.BOLD,18)  );

    BnOk.setPreferredSize( BnESC.getPreferredSize() );


    JPanel pn = new JPanel();
    pn.add(BnOk);
    pn.add(BnESC);
//    pn.setBackground(Color.green);
    this.getContentPane().add(pn,
           new GridBagConstraints(0, 3, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(0,0,0,0), 0, 0));

    BnOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnOk_Click();
      }
    });
    BnESC.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnESC_Click();
      }
    });

    // Neue Version
    // setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);


  }


  private void BnOk_Click() {
    // Check Input, Leerzeichen an den Enden werden gelscht
    sRet1 = TName.getText().trim();
    if ( sRet1.length()==0) {
        TName.requestFocus();
      basis.Message("Eingabe","Bitte tragen Sie einen Wert im Namen ein");
      return;
    }
    sRet2 = TSalary.getText().trim();
    if ( sRet2.length()==0) {
        TSalary.requestFocus();
      basis.Message("Eingabe","Bitte tragen Sie einen Wert in Gehalt ein");
      return;
    }
    int i = CDept.getSelectedIndex();  // hier der Name
    sRet3 = (String) liste1.elementAt(i);  // hier die Nummer !!!!
    // nun Aktion mit dem Text
    result=true;
     dispose();
  }

  private void BnESC_Click(){
     dispose();
  }

  public boolean getResult ()
  {
    return result ;
  }

}

/*
 *UPDATE KUNDE
SET SALDO=61615, KREDIT=81674
WHERE ( KUNDENNR = 1);

 **/

class basis {
    /**
    * description: Zeigt eine Nachricht an   
    * @see Message, Yes-No, Yes-No-Esc, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return keinen
    * @exception keine
    */
  public static void Message( String sTitle, String sMessage) {
    JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.DEFAULT_OPTION,
      JOptionPane.INFORMATION_MESSAGE);  // Symbol
    /*  Optionen der Schalter:
         DEFAULT_OPTION    Ok
         YES_NO_OPTION
         YES_NO_CANCEL_OPTION
         OK_CANCEL_OPTION
     */
     /*  Symbole:
      ERROR_MESSAGE
      INFORMATION_MESSAGE
      WARNING_MESSAGE
      QUESTION_MESSAGE
      PLAIN_MESSAGE
     */

  } // Message


}